## seqan-raptor 2.0.0.0.git.fecfbca%2Bds

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,dversionmangle=auto,repacksuffix=+ds" \
  https://github.com/seqan/raptor/tags (?:.*?/)?raptor-v?@ANY_VERSION@@ARCHIVE_EXT@
