=== debian/changelog ===
seqan-raptor (2.0.0.0.git.fecfbca+ds-3) unstable; urgency=medium

  * Append the CPPFLAGS, not overwrite it
  * Don't compile with -march=native
  * Revert: Upstream says doxygen docs aren't ready yet, so skip that for now.
  * Also include man page for raptor build
  * d/rules: build hardening
  * d/control: remove first-person language from the descriptions
  * d/control: -doc goes in the doc section
  * d/patches/spelling: fix a typo

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 01 Nov 2022 13:00:02 +0100

seqan-raptor (2.0.0.0.git.fecfbca+ds-2) unstable; urgency=medium

  * Generate and package the man pages.
  * Upstream says doxygen docs aren't ready yet, so skip that for now.
  * d/patches/privacy: don't phone home to check for a new version
  * d/patches/debian_xxhash: get the libdir using pkg-config (Closes:
    #1023176)

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 31 Oct 2022 11:43:26 +0100

seqan-raptor (2.0.0.0.git.fecfbca+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1022057)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Oct 2022 18:58:32 +0200
